/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "winner.h"

void _pokerGameActionWinnerOnStart(
  queue_t *queue, queueaction_t *action, uint8_t i
) {
  pokergame_t *game = (pokergame_t *)action->data;
  printf("Winner start action");
  pokerWinnerCalculate(
    &game->poker.winner,
    &game->poker.dealer,
    game->poker.players
  );

  printf("Winner Count %u\n", game->poker.winner.winnerCount);
  for(uint8_t i = 0; i < game->poker.winner.winnerCount; i++) {
    uint8_t winner = game->poker.winner.winners[i];
    printf("Winner %u\n", winner);
  }

  pokerGameActionRoundAdd(game);
  queueNext(queue);
}

queueaction_t * pokerGameActionWinnerAdd(pokergame_t *game) {
  queueaction_t *action = pokerGameActionAdd(game);
  action->onStart = &_pokerGameActionWinnerOnStart;
  return action;
}